<template>
    <div
        v-if="subPopup"
        class="page-container"
    >
        <div class="video-button-container">
            <!--            <VideoButton :id="helpModalId">-->
            <!--                <div slot="iframe">-->
            <!--                    <iframe-->
            <!--                        class="embed-responsive-item"-->
            <!--                        src="https://carti.crisp.help/en/article/enable-email-cart-abandonment-automation-1oxiee1/"-->
            <!--                        allowfullscreen-->
            <!--                    />-->
            <!--                </div>-->
            <!--            </VideoButton>-->
        </div>
        <ValidationObserver
            ref="obs"
            v-slot="{handleSubmit}"
        >
            <form
                @submit.prevent="handleSubmit(saveReminder)"
            >
                <div class="row form-header-container">
                    <div class="col-12 col-xl-6 ">
                        <div class="edit__actions">
                            <div>
                                <b-btn
                                    class="btn blue-btn"
                                    @click="saveReminder"
                                >
                                    Save
                                </b-btn>
                            </div>
                        </div>

                        <b-tabs pills>
                            <b-tab
                                title="Text editor"
                                active
                            >
                                <TextEditor :text-editor="subPopup.notif" />
                            </b-tab>
                            <b-tab title="Design editor">
                                <DesignEditor
                                    :notif="subPopup.notif"
                                    :design="design"
                                />
                            </b-tab>
                        </b-tabs>
                    </div>
                    <div class="col-12 col-xl-6 ">
                        <div class="button-group action-container">
                            <div>
                                <b-btn
                                    class="btn blue-btn"
                                    @click="saveReminder"
                                >
                                    Save
                                </b-btn>
                            </div>
                        </div>
                        <SubCartExample
                            :notif="subPopup.notif"
                            :welcome="subPopup.welcome"
                            :design="design"
                            class="cart-example"
                        />
                    </div>
                </div>
            </form>
        </ValidationObserver>
    </div>
</template>

<script>
import TextEditor from "../../../components/push/growth/subscription/TextEditor";
import SubCartExample from "../../../components/push/growth/subscription/SubCartExample";
import subscription from "../../../mixins/push/growth.service"
import DesignEditor from "../../../components/push/growth/subscription/DesignEditor";

export default {
    name: "EditSub",
    components: {DesignEditor, SubCartExample, TextEditor},
    mixins: [subscription],
    data: () => ({
        subPopup: null,
        previewPopup: false,
        helpModalId: 'HelpModalEmailAdandonedCarts',
        design: {
            headerText: {
                color: {hex: ''},
                active: false
            },
            bodyText: {
                color: {hex: ''},
                active: false
            },
            disallowText: {
                color: {hex: ''},
                active: false
            },
            allowBackground: {
                color: {hex: ''},
                active: false
            },
            allowColor: {
                color: {hex: ''},
                active: false
            },
            windowBackgroundColor: {
                color: {hex: ''},
                active: false
            },
        },

    }),
    mounted() {
        this.getSubscriptionPopup()
    },
    methods: {
        async getSubscriptionPopup() {
            this.subPopup = await this.getGrowthDashboard()
            this.design.headerText.color.hex = this.subPopup.notif.colors.header_text
            this.design.bodyText.color.hex = this.subPopup.notif.colors.body_text
            this.design.disallowText.color.hex = this.subPopup.notif.colors.disallow_text
            this.design.allowBackground.color.hex = this.subPopup.notif.colors.allow_background
            this.design.allowColor.color.hex = this.subPopup.notif.colors.allow_color
            this.design.windowBackgroundColor.color.hex = this.subPopup.notif.colors.window_background_color
        },
        async saveReminder() {
            this.subPopup.notif.colors.header_text = this.design.headerText.color.hex;
            this.subPopup.notif.colors.body_text = this.design.bodyText.color.hex;
            this.subPopup.notif.colors.disallow_text = this.design.disallowText.color.hex;
            this.subPopup.notif.colors.allow_background = this.design.allowBackground.color.hex;
            this.subPopup.notif.colors.allow_color = this.design.allowColor.color.hex;
            this.subPopup.notif.colors.window_background_color = this.design.windowBackgroundColor.color.hex;
            const result = await this.$refs.obs.validate();
            let valid = await this.$refs.obs
            if (result) {
                this.updatePopup(this.subPopup.notif).then(() => {
                    this.$notify({
                        type: 'success',
                        title: 'Saved'
                    });
                    // this.$router.push('/push/growth')
                    setTimeout(() => {
                        this.$refs.obs.reset()
                    }, 2000)
                })
            } else this.getFormErrors(valid.errors)
        }
    }
}
</script>

<style scoped>

.cart-example {
    margin-top: 2em;
    margin-left: auto;
    margin-right: auto;
}

</style>
